from __future__ import division
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4.uic import *
from math import *
#new:
import platform
import d2xx

class SplashForm(QWidget):
    def __init__(self, parent=None):
        self.paused = False ##################################
        super(SplashForm, self).__init__(parent)
        self.current_pic_number = 0
        nAcross = 20
        nDown = 10
        layout = QGridLayout()
        self.QL = []
        self.QL_logo = QLabel()
        self.QL_logo.setPixmap(QPixmap("windowLogo.png"))
        layout.addWidget(self.QL_logo,1,1,nDown-1,nAcross-1)
        for i in range(0,nAcross):
            self.QL.append(QLabel())
            self.QL[-1].setPixmap(QPixmap("dot0.png"))
            layout.addWidget(self.QL[-1],0,i)
        for i in range(0,nDown):
            self.QL.append(QLabel())
            self.QL[-1].setPixmap(QPixmap("dot0.png"))
            layout.addWidget(self.QL[-1],i,nAcross)
        for i in range(nAcross,0,-1):
            self.QL.append(QLabel())
            self.QL[-1].setPixmap(QPixmap("dot0.png"))
            layout.addWidget(self.QL[-1],nDown,i)
        for i in range(nDown,0,-1):
            self.QL.append(QLabel())
            self.QL[-1].setPixmap(QPixmap("dot0.png"))
            layout.addWidget(self.QL[-1],i,0)    
        loadMsg = QLabel("<font color=red size=32><i>Establishing window communications. Please Wait...</i></font>")
        layout.addWidget(loadMsg,9,1,1,20)
        self.setWindowFlags(Qt.SplashScreen)
        self.setLayout(layout)
        #for waiting and updating the GUI
        self.timer = QBasicTimer()
        self.step = 20 + 20 + 10 + 5
        self.timer.start(60,self)
    def timerEvent(self,event):
        if(self.paused == False): #####################
            self.step += 1
            self.advanceSplashScreenGraphic(self.step)
    def advanceSplashScreenGraphic(self, i):
        self.QL[i%len(self.QL)].setPixmap(QPixmap("dot" + str(self.current_pic_number) + ".png"))
        if i%(20 + 20 + 10 + 10) == 0:
            self.current_pic_number = (self.current_pic_number + 1)%5
    def pause(self): ######################
        self.paused = True
    def resume(self): ######################
        self.paused = False