#Libraries:
from __future__ import division
import sys
import time
import os
import platform
import d2xx
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4.uic import *
from math import *
#My classes:
from SplashForm import *
from AllWindows import *
from SendToMicro import *
#import Commands
from Commands import *
from RigUp import *
#######################
import urllib
#######################

#Multithreading:
from multiprocessing import Process, Lock, Value, Array, Pipe

class WholeProgram:

    ############################################################################################# 
    def checkForWindowChanges(self):
        def getStateOfWindowX(i):
            STATE_OPENED = -1
            STATE_MIDDLE = 0
            STATE_CLOSED = 1
            theurl = 'http://129.74.154.171/observer/media.php?id=1267301014&uid=5619109'
            if i != 1:
                theurl = 'http://129.74.154.171/observer/media.php?id=1267369485&uid=5619109'
            f = urllib.urlopen(theurl)
            s = f.read()
            f.close()
            #<RATING user_rated="-1" up_count="0" down_count="1"/>
            iStart = s.find('user_rated')
            iEnd   = s.find('up_count')
            s = s[iStart:iEnd]
        #    print s
            if(s.count('-1') > 0):
                return STATE_OPENED
            elif(s.count('1') > 0):
                return STATE_CLOSED 
            else:
                return STATE_MIDDLE
        print 'Starting checkForWindowChanges...'
        while True:
            win1_old_state      = getStateOfWindowX(1)
            win1_current_state  = getStateOfWindowX(1)
            win2_old_state      = getStateOfWindowX(2)
            win2_current_state  = getStateOfWindowX(2)
            while((win1_old_state == win1_current_state) and (win2_old_state == win2_current_state)):
                win1_current_state = getStateOfWindowX(1)
                win2_current_state = getStateOfWindowX(2)
#                print '.',
                time.sleep(.5)
            if(win1_old_state != win1_current_state): #window 1 command sent
                if win1_current_state == -1:
                    Commands().sendSimpleCommand(0, cmd_open=True)
                elif win1_current_state == 0:
                    Commands().sendSimpleCommand(0, cmd_middle=True)
                else:
                    Commands().sendSimpleCommand(0, cmd_close=True)
#                print 'Window 1 has a new state.... ' + str(win1_current_state)
            elif(win2_old_state != win2_current_state): #window 2 command sent 
                if win2_current_state == -1:
                    Commands().sendSimpleCommand(1, cmd_open=True)
                elif win2_current_state == 0:
                    Commands().sendSimpleCommand(1, cmd_middle=True)
                else:
                    Commands().sendSimpleCommand(1, cmd_close=True)   
#                print 'Window 2 has a new state.... ' + str(win2_current_state)
    ##############################################################################################

    #This function does opening animation
    def openingAnimation(self):
        app = QApplication(sys.argv)
        app.quitOnLastWindowClosed()
        sform = SplashForm()
        sform.show()
        app.exec_()
    
    ########################################################################
    #This function constantly listens for incoming microcontroller commands:
#    def constantListening(self):
#        while(1):
#            xyz = SendToMicro().receive()
#            print xyz,
#            sys.stdout.flush()
#            print str(self.f1)
#            self.f1.setWindowTitle("TEST")
    ########################################################################
    
    def __init__(self):
        #########One of these is to listen for android, the other is the regular program##
        with open('alternate.txt','r') as f:
            type = f.read().strip()
        ###################################################################################
#        type = '1' #//////////////////// TO DISABLE ANDROID LISTENING //////////////////
        if type == '0':
            with open('alternate.txt','w') as f:
                type = f.write('1')
            android = Process(target=self.checkForWindowChanges())
            android.start()
        else:
            with open('alternate.txt','w') as f:
                type = f.write('0')
            app = QApplication(sys.argv)
            app.quitOnLastWindowClosed()
            fakeComm = Process(target=self.openingAnimation)
            fakeComm.start() #start splash screen
            self.f1 = AllWindows() #wait for real stuff to happen
            fakeComm.terminate() #kill splash screen
            self.f1.show()
            app.exec_()
            print "done."

if __name__ == '__main__':
    wp = WholeProgram()
    print "got here"

